<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Document</title>

    <link
      href="https://cdn.jsdelivr.net/npm/bootstrap@5.3.1/dist/css/bootstrap.min.css"
      rel="stylesheet"
      integrity="sha384-4bw+/aepP/YC94hEpVNVgiZdgIC5+VKNBQNGCHeKRQN+PtmoHDEXuppvnDJzQIu9"
      crossorigin="anonymous"
    />
    <script
      src="https://cdn.jsdelivr.net/npm/bootstrap@5.3.1/dist/js/bootstrap.bundle.min.js"
      integrity="sha384-HwwvtgBNo3bZJJLYd8oVXjrBZt8cqVSpeBNS5n7C8IVInixGAoxmnlMuBnhbgrkm"
      crossorigin="anonymous"
    ></script>

    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.7.0/jquery.min.js"></script>

    <link rel="preconnect" href="https://fonts.googleapis.com" />
    <link rel="preconnect" href="https://fonts.gstatic.com" crossorigin />
    <link
      href="https://fonts.googleapis.com/css2?family=Squada+One&display=swap"
      rel="stylesheet"
    />
    <link
      href="https://fonts.googleapis.com/css2?family=Inter&display=swap"
      rel="stylesheet"
    />

    <link href="https://fonts.cdnfonts.com/css/gilroy-bold" rel="stylesheet" />
    <link
      href="https://fonts.cdnfonts.com/css/sf-pro-display"
      rel="stylesheet"
    />
    <link
      href="https://fonts.googleapis.com/css2?family=ABeeZee&display=swap"
      rel="stylesheet"
    />
    <link
      href="https://fonts.googleapis.com/css2?family=Lexend+Deca&display=swap"
      rel="stylesheet"
    />
    <link
      href="https://fonts.googleapis.com/css2?family=Poppins&display=swap"
      rel="stylesheet"
    />
    <link
      href="https://fonts.googleapis.com/css2?family=ABeeZee&display=swap"
      rel="stylesheet"
    />

    <link rel="stylesheet" href="style.css" />
  </head>
  <body>
    <div
      class="header-section min-vh-100"
      style="background: var(--primary-green, #1ac073);"
    >
      <nav
        class="navbar navbar-expand-lg"
        style="background: var(--primary-green, #1ac073);"
      >
        <div class="container">
          <a class="navbar-brand what2eat" href="#">WHAT2EAT</a>
          <button
            class="navbar-toggler"
            type="button"
            data-bs-toggle="collapse"
            data-bs-target="#navbarSupportedContent"
            aria-controls="navbarSupportedContent"
            aria-expanded="false"
            aria-label="Toggle navigation"
          >
            <span class="navbar-toggler-icon"></span>
          </button>
          <div class="collapse navbar-collapse" id="navbarSupportedContent">
            <ul class="navbar-nav mb-2 mb-lg-0 centering-margin-lr">
              <li class="nav-item mx-1">
                <a
                  class="nav-link active link-light"
                  aria-current="page"
                  href="#"
                  >Home</a
                >
              </li>
              <li class="nav-item mx-1">
                <a
                  class="nav-link active link-light"
                  aria-current="page"
                  href="#"
                  >About</a
                >
              </li>
              <li class="nav-item mx-1">
                <a
                  class="nav-link active link-light"
                  aria-current="page"
                  href="#"
                  >Menu</a
                >
              </li>
              <li class="nav-item mx-1">
                <a
                  class="nav-link active link-light"
                  aria-current="page"
                  href="#"
                  >Blog</a
                >
              </li>
              <li class="nav-item mx-1">
                <a
                  class="nav-link active link-light"
                  aria-current="page"
                  href="#"
                  >Contact</a
                >
              </li>
            </ul>
            <div class="d-flex">
              <img
                class="nav-bar-icon"
                style="margin-right: 1rem;"
                src="images/akar-icons_search.png"
                alt=""
              />
              <img
                id="img-shopping-bag"
                class="nav-bar-icon"
                src="images/akar-icons_shopping-bag.png"
                alt=""
              />
            </div>
          </div>
        </div>
      </nav>

      <div class="row">
        <div class="col-lg-6" style="padding-left: 6rem;">
          <div class="tittle">Authentic Home food in UK</div>
          <div class="sub-tittle">
            What2Eat is a courier service in which authentic home cook food is
            delivered to a customer.
          </div>
          <div
            class="input-group"
            style="margin-top: 40px; margin-bottom: 233px; max-width: 80%;"
          >
            <input
              type="text"
              class="form-control border-0"
              name="x"
              placeholder="Search food you love"
            />
            <span
              class="input-group-text bg-warning text-light border-0"
              id="addon-wrapping"
              >Search</span
            >
          </div>
        </div>
        <div class="col-lg-6">
          <div class="centering-flex" style="height: 100%;">
            <div class="bg-image"></div>
          </div>
        </div>
      </div>
    </div>

    <div class="main-section container" style="margin-bottom: 25rem;">
      <nav
        aria-label="breadcrumb"
        style="margin-top: 13rem; margin-bottom: 13rem;"
      >
        <ol class="breadcrumb my-bread">
          <li class="breadcrumb-item" style="color: #1ac073;">Home</li>
          <li class="breadcrumb-item" style="color: #1ac073;">Trending</li>
          <li class="breadcrumb-item">Famous Tandoor</li>
        </ol>
      </nav>

      <div class="row">
        <div
          class="col-6 column-tittle"
          style="text-align: start; padding-left: 3rem;"
        >
          PRODUCT
        </div>
        <div class="col-2 column-tittle">PRICE</div>
        <div class="col-2 column-tittle">QTY</div>
        <div class="col-2 column-tittle">UNIT PRICE</div>
      </div>

      <div class="divider-gh" style="margin-top: 4rem;"></div>

      <div id="pizza-container"></div>

      <div class="row mt-9" style="margin-top: 9rem;">
        <div class="col-md-6">
          <div class="input-group" style="max-width: 80%; margin-bottom: 3rem;">
            <input
              type="text"
              class="form-control"
              placeholder="Voucher code"
              id="voucher-code-input"
            />
            <span
              class="input-group-text text-light border-0"
              style="
                background-color: #1ac073;
                padding: 1rem 1.8rem 1rem 1.8rem;
              "
              id="redeem-span"
              >Redeem</span
            >
          </div>
        </div>
        <div class="col-md-6" style="padding-left: 7rem;">
          <div class="flex-space-between">
            <div class="pay-sub-text">Subtotal</div>
            <div class="pay-sub-text">
              <span>$</span><span id="sub-total"></span>
            </div>
          </div>

          <div
            class="flex-space-between"
            style="margin-top: 2rem; margin-bottom: 2rem;"
          >
            <div class="pay-sub-text">Shipping fee</div>
            <div class="pay-sub-text">$20</div>
          </div>

          <div class="flex-space-between">
            <div class="pay-sub-text">Coupon</div>
            <div class="pay-sub-text" id="coupon-div">No</div>
          </div>

          <div
            class="flex-space-between"
            style="margin-top: 4rem; margin-bottom: 1rem;"
          >
            <div class="pay-main-text">TOTAL</div>
            <div class="pay-main-text">
              <span>$</span><span id="total"></span>
            </div>
          </div>

          <button class="btn-check-out" id="btn-check-out">Check out</button>
        </div>
      </div>
    </div>

    <div
      style="background: var(--primary-green, #1ac073); padding-bottom: 1rem;"
    >
      <div class="container">
        <nav
          class="navbar navbar-expand-lg"
          style="background: var(--primary-green, #1ac073);"
        >
          <div class="container">
            <a class="navbar-brand what2eat" href="#">WHAT2EAT</a>
            <button
              class="navbar-toggler"
              type="button"
              data-bs-toggle="collapse"
              data-bs-target="#navbarSupportedContent"
              aria-controls="navbarSupportedContent"
              aria-expanded="false"
              aria-label="Toggle navigation"
            >
              <span class="navbar-toggler-icon"></span>
            </button>
            <div class="collapse navbar-collapse" id="navbarSupportedContent">
              <ul class="navbar-nav mb-2 mb-lg-0 centering-margin-lr">
                <li class="nav-item mx-1">
                  <a
                    class="nav-link active link-light"
                    aria-current="page"
                    href="#"
                    >Home</a
                  >
                </li>
                <li class="nav-item mx-1">
                  <a
                    class="nav-link active link-light"
                    aria-current="page"
                    href="#"
                    >About</a
                  >
                </li>
                <li class="nav-item mx-1">
                  <a
                    class="nav-link active link-light"
                    aria-current="page"
                    href="#"
                    >Menu</a
                  >
                </li>
                <li class="nav-item mx-1">
                  <a
                    class="nav-link active link-light"
                    aria-current="page"
                    href="#"
                    >Blog</a
                  >
                </li>
                <li class="nav-item mx-1">
                  <a
                    class="nav-link active link-light"
                    aria-current="page"
                    href="#"
                    >Contact</a
                  >
                </li>
              </ul>
              <div class="d-flex">
                <div
                  class="nav-bar-icon face-icon-container centering-flex nav-bar-icon"
                >
                  <img
                    src="images/facebook-icon.png"
                    style="height: 15px;"
                    alt=""
                  />
                </div>
                <img
                  class="nav-bar-icon"
                  src="images/iconoir_footer2.png"
                  alt=""
                />
              </div>
            </div>
          </div>
        </nav>
        <div class="container">
          <div class="divider"></div>
        </div>
      </div>
      <div class="copyright text-center">Copyright @2021 What2Eat</div>
    </div>

    <!-- Make payment modal -->
    <div class="modal fade" id="modal-payment" role="dialog">
      <div class="modal-dialog modal-lg">
        <div class="modal-content">
          <div class="modal-body px-5 text-center">
            <div style="text-align: end; margin-top: 1rem;">
              <button
                type="button"
                data-bs-dismiss="modal"
                style="border: 0px; background-color: inherit;"
              >
                <img src="images/icon-close.png" alt="" />
              </button>
            </div>
            <div class="make-payment">Make Payment</div>
            <div class="centering-flex my-5">
              <div class="step-1 centering-flex">1</div>
              <div class="connector"></div>
              <div class="step-2 centering-flex">2</div>
            </div>

            <form action="">
              <div class="row">
                <div class="col-lg-6">
                  <input
                    type="text"
                    placeholder="First Name"
                    class="modal-input"
                    id="modal-input-firstname"
                  />
                  <input
                    type="text"
                    placeholder="Email Address"
                    class="modal-input"
                    id="modal-input-email"
                    style="margin-top: 2rem; margin-bottom: 2rem;"
                  />

                  <div class="payment" style="margin-bottom: 1rem;">
                    Select Method of Payment
                  </div>
                  <div class="pay-container" id="div-pay-credit">
                    <img src="images/Credit-Card.png" class="pay-icon" />
                    <div class="pay-name">Credit Card Or Debit</div>
                    <div class="pay-check-box centering-flex">
                      <img src="images/unchecked.png" alt="" />
                    </div>
                  </div>

                  <div class="pay-container" id="div-pay-paypal">
                    <img src="images/Paypal.png" class="pay-icon" />
                    <div class="pay-name">Paypal</div>
                    <div class="pay-check-box centering-flex">
                      <img src="images/unchecked.png" alt="" />
                    </div>
                  </div>

                  <div class="pay-container" id="div-pay-bank">
                    <img src="images/Bank.png" class="pay-icon" />
                    <div class="pay-name">Bank Transfer</div>
                    <div class="pay-check-box centering-flex">
                      <img src="images/unchecked.png" alt="" />
                    </div>
                  </div>
                </div>
                <div class="col-lg-6">
                  <input
                    type="text"
                    placeholder="Last Name"
                    id="modal-input-lastname"
                    class="modal-input"
                  />
                  <textarea
                    placeholder="Address for Delivery"
                    class="modal-input"
                    id="modal-textarea-address"
                    style="height: 8rem; margin-top: 2rem; margin-bottom: 2rem;"
                  >
                  </textarea>
                  <input
                    type="text"
                    placeholder="Mobile Phone"
                    id="modal-input-phone"
                    class="modal-input"
                  />
                </div>
              </div>
            </form>

            <div>
              <button class="pay-button" id="btn-go-to-payment">
                Go to Payment
              </button>
            </div>
          </div>
        </div>
      </div>
    </div>

    <!-- Make payment success modal -->
    <div class="modal fade" id="modal-payment-success" role="dialog">
      <div class="modal-dialog modal-lg">
        <div class="modal-content">
          <div class="modal-body px-5 text-center">
            <div style="text-align: end; margin-top: 1rem;">
              <button
                type="button"
                data-bs-dismiss="modal"
                style="border: 0px; background-color: inherit;"
              >
                <img src="images/icon-close.png" alt="" />
              </button>
            </div>
            <div class="make-payment">Make Payment</div>
            <div class="centering-flex my-5">
              <div class="step-1 centering-flex">1</div>
              <div class="connector"></div>
              <div class="step-1 centering-flex">2</div>
            </div>

            <img
              src="images/SuccessIcon.png"
              style="width: 10rem; height: 10rem;"
            />
            <div class="pay-success mb-5">Success</div>

            <div>
              <button class="pay-button" id="modal-success-btn-complete">
                Complete
              </button>
            </div>
          </div>
        </div>
      </div>
    </div>
  </body>
</html>

<script>
  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
  var gGioHang = [];
  var gPizzaPriceList = [];
  var gVoucherId = "";

  const gPAY_CREDIT = "CreditCard";
  const gPAY_PAYPAL = "Paypal";
  const gPAY_BANK_TRANSFER = "BankTransfer";

  var gBASE_URL = "https://64747ed27de100807b1b0fa4.mockapi.io/api/v1/";
  /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
  onPageLoading();

  $(document).on("click", ".counter-minus", function () {
    onMinusChangeClick(this);
  });

  $(document).on("click", ".counter-plus", function () {
    onPlusChangeClick(this);
  });

  $(document).on("click", ".remove-item", function () {
    onRemoveClick(this);
  });

  $("#redeem-span").click(function () {
    onRedeemSpanClick();
  });

  $("#btn-check-out").click(function () {
    $("#modal-payment").modal("show");
  });

  $(document).on(
    "click",
    "#div-pay-credit, #div-pay-paypal, #div-pay-bank",
    function () {
      var vId = $(this).attr("id");
      markSelectedPay(vId);
    }
  );

  //gán sự kiện cho nút Go to payment trên modal
  $(document).on("click", "#btn-go-to-payment", function () {
    onBtnGoToPaymentClick();
  });

  //gán sự kiện cho nút Complete trên modal
  $(document).on("click", "#modal-success-btn-complete", function () {
    $("#modal-payment-success").modal("hide");
  });
  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
  //hàm thực thi khi tải trang
  function onPageLoading() {
    var vGioHangString = localStorage.getItem("gioHang");
    if (vGioHangString != null) {
      gGioHang = JSON.parse(vGioHangString);
      if (gGioHang.length > 0) {
        //đổi icon shopping bag thành màu vàng
        $("#img-shopping-bag").attr(
          "src",
          "images/akar-icons_shopping-bag-yellow.png"
        );

        //hiển thị các pizza đã chọn
        getPizzaPriceList();
        loadPizzaOnWeb();
      }
    }

    //tính sub total và hiển thị lên web
    var vSubTotal = tinhSubTotal();
    $("#sub-total").html(vSubTotal);
    $("#total").html(vSubTotal + 20);
  }

  //hàm thực thi khi nhấn nút + trên cột QTY
  function onPlusChangeClick(paramElement) {
    var vId = $(paramElement).attr("data-id");
    var vPizzaPriceIndex = getPizzaPriceIndexById(vId);
    var vPizzaPriceObj = gPizzaPriceList[vPizzaPriceIndex];

    //tăng số lượng lên 1 và lưu vào gPizzaPriceList
    var vQty = vPizzaPriceObj.qty + 1;
    $(paramElement).prev().html(vQty);
    gPizzaPriceList[vPizzaPriceIndex].qty = vQty;

    //tăng price và lưu vào gPizzaPriceList
    var vPriceElement = $(paramElement)
      .parent()
      .parent()
      .prev()
      .children()
      .eq(1);
    var vNewPrice = vPizzaPriceObj.price + vPizzaPriceObj.unitPrice;
    vPriceElement.html(vNewPrice);
    gPizzaPriceList[vPizzaPriceIndex].price = vNewPrice;

    //tính sub total và hiển thị lên web
    var vSubTotal = tinhSubTotal();
    $("#sub-total").html(vSubTotal);
    $("#total").html(vSubTotal + 20);

    $("#voucher-code-input").val("");
    $("#coupon-div").html("No");
  }

  //hàm thực thi khi nhấn nút - trên cột QTY
  function onMinusChangeClick(paramElement) {
    var vQtyElement = $(paramElement).next();
    var vQty = parseFloat(vQtyElement.html());
    if (vQty > 1) {
      var vNewQty = vQty - 1;
      vQtyElement.html(vNewQty);

      var vId = $(paramElement).attr("data-id");
      var vPizzaPriceIndex = getPizzaPriceIndexById(vId);
      gPizzaPriceList[vPizzaPriceIndex].qty = vNewQty;

      //giảm price và lưu vào gPizzaPriceList
      var vPizzaPriceObj = gPizzaPriceList[vPizzaPriceIndex];
      var vNewPrice = vPizzaPriceObj.price - vPizzaPriceObj.unitPrice;
      var vPriceElement = $(paramElement)
        .parent()
        .parent()
        .prev()
        .children()
        .eq(1);
      vPriceElement.html(vNewPrice);
      gPizzaPriceList[vPizzaPriceIndex].price = vNewPrice;

      //tính sub total và hiển thị lên web
      var vSubTotal = tinhSubTotal();
      $("#sub-total").html(vSubTotal);
      $("#total").html(vSubTotal + 20);

      $("#voucher-code-input").val("");
      $("#coupon-div").html("No");
    }
  }

  //hàm thực thi khi nhấn Remove Item
  function onRemoveClick(paramElement) {
    var vObjId = $(paramElement).attr("data-id");

    //tính lại và hiển thị sub total
    var vPriceElement = $(paramElement).parent().prev().children().eq(1);
    var vRemovePrice = parseFloat(vPriceElement.html());
    var vSubTotal = parseFloat($("#sub-total").html());
    var vNewSubTotal = vSubTotal - vRemovePrice;
    $("#sub-total").html(vNewSubTotal);
    $("#total").html(vNewSubTotal + 20);

    $("#voucher-code-input").val("");
    $("#coupon-div").html("No");

    //xóa pizza trong gGioHang, gPizzaPriceList
    for (var bI = 0; bI < gGioHang.length; bI++) {
      if (gGioHang[bI] == vObjId) {
        gGioHang.splice(bI, 1);
        gPizzaPriceList.splice(bI, 1);
      }
    }
    console.log(gPizzaPriceList);
    //lưu lại local storage
    localStorage.setItem("gioHang", JSON.stringify(gGioHang));

    //load lại danh sách pizza đã chọn
    $("#pizza-container").html("");
    loadPizzaOnWeb();
  }

  //hàm thực thi khi nhấn nút Redeem
  function onRedeemSpanClick() {
    var vVoucherCode = $("#voucher-code-input").val();

    if (vVoucherCode != "") {
      var vQueryVoucherCode = {
        voucherCode: vVoucherCode,
      };
      var vSearchParams = new URLSearchParams(vQueryVoucherCode);

      $.ajax({
        url:
          "https://food-ordering-fvo9.onrender.com/api/vouchers" +
          "?" +
          vSearchParams.toString(),
        type: "GET",
        success: function (res) {
          xuLiGiamGia(res);
        },
        error: function (ajaxContext) {
          alert(ajaxContext.responseText);
        },
      });
    } else {
      alert("Bạn cần nhập mã giảm giá!");
    }
  }

  //hàm thực thi khi nhấn nút Go to payment trên modal
  function onBtnGoToPaymentClick() {
    var vOrderObj = {
      firstName: "",
      lastName: "",
      email: "",
      address: "",
      methodPayment: "",
      phone: "",
    };

    //B1: đọc dữ liệu đơn hàng trên modal
    readOrderData(vOrderObj);
    //B2: kiểm tra dữ liệu đơn hàng
    var vCheck = validateOrderData(vOrderObj);
    if (vCheck) {
      var vDetails = [];
      for (var bI = 0; bI < gPizzaPriceList.length; bI++) {
        var vPizzaPriceObj = gPizzaPriceList[bI];
        var vDetailObj = {
          foodId: vPizzaPriceObj.id,
          quantity: vPizzaPriceObj.qty,
        };
        vDetails.push(vDetailObj);
      }
      //B3: gọi api tạo đơn hàng
      if ($("#voucher-code-input").val() == "") {
        goiApiKhongVoucher(vOrderObj, vDetails);
      } else {
        goiApiCoVoucher(vOrderObj, vDetails);
      }
    }
  }
  /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
  //hàm lấy list pizza từ api và chuyển thành mảng pizza price list object
  function getPizzaPriceList() {
    $.ajax({
      url: gBASE_URL + "pizza",
      type: "GET",
      dataType: "json", // added data type
      async: false,
      success: function (res) {
        for (var bI = 0; bI < gGioHang.length; bI++) {
          var vPizzaObj = getPizzaObjById(res, gGioHang[bI]);
          var vPizzaPriceObj = {
            id: vPizzaObj.id,
            imageUrl: vPizzaObj.imageUrl,
            name: vPizzaObj.name,
            unitPrice: vPizzaObj.price,
            qty: 1,
            price: vPizzaObj.price,
          };
          gPizzaPriceList.push(vPizzaPriceObj);
        }
        console.log(gPizzaPriceList);
      },
      error: function (ajaxContext) {
        alert(ajaxContext.responseText);
      },
    });
  }

  //hàm lấy pizza obj theo id
  function getPizzaObjById(paramList, paramId) {
    var vFound = false;
    var vFoundObj = null;
    var vI = 0;
    while (!vFound && vI < paramList.length) {
      if (paramList[vI].id == paramId) {
        vFoundObj = paramList[vI];
        vFound = true;
      } else {
        vI++;
      }
    }
    return vFoundObj;
  }

  //hàm lấy index của pizza price obj trong mảng gPizzaPriceList dựa vào id
  function getPizzaPriceIndexById(paramId) {
    var vFound = false;
    var vFoundIndex = -1;
    var vI = 0;
    while (!vFound && vI < gPizzaPriceList.length) {
      if (gPizzaPriceList[vI].id == paramId) {
        vFoundIndex = vI;
        vFound = true;
      } else {
        vI++;
      }
    }
    return vFoundIndex;
  }

  //hàm load pizza lên trang web
  function loadPizzaOnWeb() {
    for (var bI = 0; bI < gPizzaPriceList.length; bI++) {
      var bOject = gPizzaPriceList[bI];
      var bHtml = `
      <div class="row">
          <div class="col-6">
            <div
              class="card"
              style="max-width: 540px; border-radius: 0px; border: 0px;"
            >
              <div class="row g-0">
                <div class="col-md-4">
                  <img
                    src="${bOject.imageUrl}"
                    class="gh-card-img"
                  />
                </div>
                <div class="col-md-8">
                  <div class="card-body pt-0">
                    <p class="gh-card-title">${bOject.name}</p>
                    <p class="gh-card-text">
                      beef patties, Iceberg lettuce, American cheese, pickles, ...
                    </p>
                  </div>
                </div>
              </div>
            </div>
          </div>
          <div class="col-2 price-unit centering-flex"><span>$</span><span>${bOject.price}</span></div>
          <div class="col-2 centering-flex" style="flex-direction: column;">
            <div class="counter">
              <div class="counter-minus" data-id="${bOject.id}">-</div>
              <div class="counter-number">${bOject.qty}</div>
              <div class="counter-plus" data-id="${bOject.id}">+</div>
            </div>
            <div class="remove-item" data-id="${bOject.id}">Remove Item</div>
          </div>
          <div class="col-2 price-unit centering-flex"><span>$</span><span>${bOject.unitPrice}</span></div>
        </div>
        <div class="divider-gh"></div>
      `;
      $("#pizza-container").append(bHtml);
    }
  }

  //hàm tính sub total
  function tinhSubTotal() {
    var vSubTotal = 0;
    for (var bI = 0; bI < gPizzaPriceList.length; bI++) {
      var vPizzaPrice = gPizzaPriceList[bI].price;
      var vPrice = parseFloat(vPizzaPrice);
      vSubTotal += vPrice;
    }
    return vSubTotal;
  }

  //hàm xử lý giảm giá, tính và hiển thị subtotal, coupon, total
  function xuLiGiamGia(paramVoucherObjArr) {
    var vSubTotal = tinhSubTotal();
    var vDiscount = 0;
    var vTotal = 0;
    if (paramVoucherObjArr.length > 0) {
      gVoucherId = paramVoucherObjArr[0].id;
      vDiscount = parseFloat(paramVoucherObjArr[0].discount);
      vSubTotal = vSubTotal * (1 - vDiscount / 100);
      vSubTotal = Number(vSubTotal.toFixed(2));
    } else {
      alert("Mã giảm giá không tồn tại");
      $("#voucher-code-input").val("");
    }

    var vTotal = vSubTotal + 20;
    $("#coupon-div").html(vDiscount + "%");
    $("#sub-total").html(vSubTotal);
    $("#total").html(vTotal);
  }

  //hàm xử lý khi chọn một Method Of Payment
  function markSelectedPay(paramId) {
    var vPaySelected = "";
    var vDivPayCredit = $("#div-pay-credit");
    var vDivPayPaypal = $("#div-pay-paypal");
    var vDivPayBank = $("#div-pay-bank");

    if (paramId == "div-pay-credit") {
      vDivPayCredit.css("background-color", "#f0faf7");
      vDivPayCredit
        .children()
        .eq(2)
        .children()
        .first()
        .attr("src", "images/check-mark.png");
      vDivPayCredit.attr("data-is-selected", "Y");
      vPaySelected = gPAY_CREDIT;

      vDivPayPaypal.css("background-color", "inherit");
      vDivPayPaypal
        .children()
        .eq(2)
        .children()
        .first()
        .attr("src", "images/unchecked.png");
      vDivPayPaypal.attr("data-is-selected", "N");

      vDivPayBank.css("background-color", "inherit");
      vDivPayBank
        .children()
        .eq(2)
        .children()
        .first()
        .attr("src", "images/unchecked.png");
      vDivPayBank.attr("data-is-selected", "N");
    } else if (paramId == "div-pay-paypal") {
      vDivPayPaypal.css("background-color", "#f0faf7");
      vDivPayPaypal
        .children()
        .eq(2)
        .children()
        .first()
        .attr("src", "images/check-mark.png");
      vDivPayPaypal.attr("data-is-selected", "Y");
      vPaySelected = gPAY_PAYPAL;

      vDivPayCredit.css("background-color", "inherit");
      vDivPayCredit
        .children()
        .eq(2)
        .children()
        .first()
        .attr("src", "images/unchecked.png");
      vDivPayCredit.attr("data-is-selected", "N");

      vDivPayBank.css("background-color", "inherit");
      vDivPayBank
        .children()
        .eq(2)
        .children()
        .first()
        .attr("src", "images/unchecked.png");
      vDivPayBank.attr("data-is-selected", "N");
    } else {
      vDivPayBank.css("background-color", "#f0faf7");
      vDivPayBank
        .children()
        .eq(2)
        .children()
        .first()
        .attr("src", "images/check-mark.png");
      vDivPayBank.attr("data-is-selected", "Y");
      vPaySelected = gPAY_BANK_TRANSFER;

      vDivPayCredit.css("background-color", "inherit");
      vDivPayCredit
        .children()
        .eq(2)
        .children()
        .first()
        .attr("src", "images/unchecked.png");
      vDivPayCredit.attr("data-is-selected", "N");

      vDivPayPaypal.css("background-color", "inherit");
      vDivPayPaypal
        .children()
        .eq(2)
        .children()
        .first()
        .attr("src", "images/unchecked.png");
      vDivPayPaypal.attr("data-is-selected", "N");
    }
  }

  //hàm đọc dữ liệu đơn hàng
  function readOrderData(paramOrderObj) {
    paramOrderObj.firstName = $("#modal-input-firstname").val().trim();
    paramOrderObj.lastName = $("#modal-input-lastname").val().trim();
    paramOrderObj.email = $("#modal-input-email").val().trim();
    paramOrderObj.address = $("#modal-textarea-address").val().trim();
    paramOrderObj.phone = $("#modal-input-phone").val().trim();

    //lấy payment method đã chọn
    var vCreditSelect = $("#div-pay-credit").attr("data-is-selected");
    var vPaypalSelect = $("#div-pay-paypal").attr("data-is-selected");
    var vBankSelect = $("#div-pay-bank").attr("data-is-selected");

    if (vCreditSelect === "Y") {
      paramOrderObj.methodPayment = gPAY_CREDIT;
    } else if (vPaypalSelect === "Y") {
      paramOrderObj.methodPayment = gPAY_PAYPAL;
    } else if (vBankSelect === "Y") {
      paramOrderObj.methodPayment = gPAY_BANK_TRANSFER;
    }
  }

  //hàm kiểm tra dữ liệu đơn hàng
  function validateOrderData(paramOrderObj) {
    if (paramOrderObj.firstName == "") {
      alert("bạn cần nhập first name!");
      return false;
    }

    if (paramOrderObj.lastName == "") {
      alert("bạn cần nhập last name!");
      return false;
    }

    if (paramOrderObj.email == "") {
      alert("bạn cần nhập email!");
      return false;
    }
    if (validateEmail(paramOrderObj.email) == false) {
      alert("Email nhập vào không đúng định dạng!");
      return false;
    }

    if (paramOrderObj.address == "") {
      alert("bạn cần nhập address!");
      return false;
    }

    if (paramOrderObj.methodPayment == "") {
      alert("bạn cần chọn một Method Of Payment!");
      return false;
    }

    if (paramOrderObj.phone == "") {
      alert("bạn cần nhập số điện thoại!");
      return false;
    }
    if (validatePhone(paramOrderObj.phone) == false) {
      alert("Số điện thoại nhập vào không đúng định dạng!");
      return false;
    }

    return true;
  }

  //hàm kiểm tra số điện thoại
  function validatePhone(paramPhone) {
    // Số điện thoại phải nhập là số, có dấu + hoặc số 0 ở đầu; độ dài từ 10 đến 12 ký tự

    if (isNaN(paramPhone)) {
      return false;
    }

    if (paramPhone.charAt(0) != "0" && paramPhone.charAt(0) != "+") {
      return false;
    }

    if (paramPhone.length < 10 || paramPhone.length > 12) {
      return false;
    }

    return true;
  }

  // hàm kiểm tra email đúng định dạng ko?
  function validateEmail(paramEmail) {
    var vValidRegex = /^(([^<>()[\]\\.,;:\s@"]+(\.[^<>()[\]\\.,;:\s@"]+)*)|.(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
    if (paramEmail.match(vValidRegex)) {
      return true;
    } else {
      return false;
    }
  }

  //hàm gọi api tạo order không voucher
  function goiApiKhongVoucher(paramOrderObj, paramDetails) {
    var vOrderCreate = {
      firstName: paramOrderObj.firstName,
      lastName: paramOrderObj.lastName,
      email: paramOrderObj.email,
      address: paramOrderObj.address,
      phone: paramOrderObj.phone,
      methodPayment: paramOrderObj.methodPayment,
      details: paramDetails,
    };

    $.ajax({
      url: "https://food-ordering-fvo9.onrender.com/api" + "/orders",
      type: "POST",
      contentType: "application/json",
      data: JSON.stringify(vOrderCreate),
      success: function (paramRes) {
        console.log(paramRes);
        // B4: xử lý front-end
        xuLiHienThi();
      },
      error: function (paramErr) {
        console.log(paramErr.status);
        alert("Lỗi tạo đơn hàng!");
        $("#modal-payment").modal("hide");
        xoaData();
      },
    });
  }

  //hàm gọi api tạo order có voucher
  function goiApiCoVoucher(paramOrderObj, paramDetails) {
    var vOrderCreate = {
      firstName: paramOrderObj.firstName,
      lastName: paramOrderObj.lastName,
      email: paramOrderObj.email,
      address: paramOrderObj.address,
      phone: paramOrderObj.phone,
      methodPayment: paramOrderObj.methodPayment,
      voucherId: gVoucherId,
      details: paramDetails,
    };

    $.ajax({
      url: "https://food-ordering-fvo9.onrender.com/api" + "/orders",
      type: "POST",
      contentType: "application/json",
      data: JSON.stringify(vOrderCreate),
      success: function (paramRes) {
        console.log(paramRes);
        // B4: xử lý front-end
        xuLiHienThi();
      },
      error: function (paramErr) {
        console.log(paramErr.status);
        alert("Lỗi tạo đơn hàng!");
        $("#modal-payment").modal("hide");
        xoaData();
      },
    });
  }

  //hàm xử lí hiển thị sau khi tạo đơn hàng thành công
  function xuLiHienThi() {
    $("#modal-payment").modal("hide");
    $("#modal-payment-success").modal("show");
    xoaData();
  }

  //hàm xóa dữ liệu cũ trên modal
  function xoaData() {
    $("#modal-input-firstname").val("");
    $("#modal-input-lastname").val("");
    $("#modal-input-email").val("");
    $("#modal-textarea-address").val("");
    $("#modal-input-phone").val("");

    $("#div-pay-credit").css("background-color", "inherit");
    $("#div-pay-credit")
      .children()
      .eq(2)
      .children()
      .first()
      .attr("src", "images/unchecked.png");
    $("#div-pay-credit").attr("data-is-selected", "N");

    $("#div-pay-paypal").css("background-color", "inherit");
    $("#div-pay-paypal")
      .children()
      .eq(2)
      .children()
      .first()
      .attr("src", "images/unchecked.png");
    $("#div-pay-paypal").attr("data-is-selected", "N");

    $("#div-pay-bank").css("background-color", "inherit");
    $("#div-pay-bank")
      .children()
      .eq(2)
      .children()
      .first()
      .attr("src", "images/unchecked.png");
    $("#div-pay-bank").attr("data-is-selected", "N");
  }
</script>
